;;----------------------;;
;; skeleton-edit.l       ;;
;;   for skeleton editor ;;
;;----------------------;;

;; ------ ;;
;; reload ;;
;; ------ ;;

(defun init_window () 'dummy-function)

(defun current-directory ()
  (let ((tmpfile (string-append "/tmp/ya" (date-time))))
    (call (string-append "echo \""`pwd`\"" > " tmpfile))
    (lets ((s (inopen (stream tmpfile)))
	   (ret (read s)))
      (close s)
      (call (string-append "rm " tmpfile))
      ret)))

(defun reload-skeleton ((load-primitive-all t))
  (reload-skeleton load-primitive-all))

(defun load-directory (dir)
  (lets ((base-directory dir))
	(exfile (string-append base-directory "/" "load.l"))))
(setq source-load t)
(defun reload-skeleton ((load-primitive-all t))
  (let ((curdir (current-directory))
	(source-of-binary-files '(			  
				  "./addhira.l"
				  "./addprim.l"
				  "./affinprim.l"
				  "./aplyknj.l"
				  "./delprim.l"
				  "./dist.l"
				  "./delhirapnt.l"
				  "./drag-line.l"
				  "./draw.l"
				  "./edhira.l"
				  "./edjoint.l"
				  "./edprim.l"
				  "./etc.l"
				  "./han2zen.l"
				  "./hirapoint.l"
				  "./init.l"
				  "./loop.l"
				  "./message.l"
				  "./movebox.l"
				  "./nolink.l"
				  "./primdef.l"
				  "./primdisp.l"
				  "./resizebox.l"
				  "./skel-lib.l"
				  "./slider.l"
				  "./whichprim.l"
				  "./xyunit.l")))
    
;    (cd "/home/misa/kanji/lib")
    
    (cond ((definedp 'connect-to-server)
	   nil)
	  (t
	   (exfile "/usr/local/lib/utilisp/ulx/loadulx.l")))
    
    (cond ((and (boundp 'source-load) (not (null source-load)))
	   (mapcar source-of-binary-files #'load))
	  (t
	   (let ((binary-files
		  (mapcar source-of-binary-files 
			  #'(lambda (name)
			      (string-append
			       (substring name 0 (1- (string-length name)))
			       "o")))))
	     (code-load binary-files))))

    (load "./skeledit.l")
    (load "./kinput.l")
    (load "./nocompile.l")
    (load "./ulxbug.l")
    (load "./primref.l")
    (load "./askyn.l")
    
    (when load-primitive-all
      (comment setq makekanjilist t)
      (load-directory "../renderer/")
      (load-directory "../primdata/")
      (load-directory "../jointdata/")
      (load-directory "../kanjidata/")
;      (load "./load.l")
;      (load "./gothic.l")
;      (load "./startup-hira.l")
;      (load "./prim-patch.l")
      )

    (cd curdir)
    nil))

(defun skeleton-edit-and-save (editee editee-name filename)
  (print editee-name terminal-output)
  (let* ((result (skeleton-edit editee))
	 (standard-output (appendopen (stream filename))))
    (prind `(setq ,editee-name ',result))
    (terpri)
    (close standard-output)))

(defun reload-ulx-tools ()
  (reload-skeleton t))
    
(reload-ulx-tools)
